Program CIBC_Club_Dialer;

{$M 16000,0,16000}
{$V-} { string checking off }
 
{ room for dos shell? }

Uses Dos, Crt, MODEM, StrnTTT5, MiscTTT5, IOTTT5, FastTTT5, WinTTT5, KeyTTT5, PullTTT5;

{ CIBC Club User Interface with "MamaMenu v1.0" }

const fone = '629-0158'; {what to dial}
      prgname = 'CLUB NAME';

type settings = record
     Name : string;
     Password : string;
     Baud : integer;
     Com : byte;
     Dialing : String;
     InitStr : string;
     end;

   Display_Cols = record
                      TextF    : byte;
                      Back     : byte;
                      MsgF     : byte;
                      MsgB     : Byte;
                      FieldHiF : byte;
                      FieldHiB : Byte;
                      FieldLoF : Byte;
                      FieldLoB : Byte;
                      BoxF     : Byte;
                      HeadF    : Byte;
                  end;


var
  TheMenu : Pull_Array;   {Array holding the menu definitions}
  Major,Minor : byte;
  Ch : char;
  X : integer;
  SettingsChanged : boolean;
  Configfile : file of settings;
  user : settings;
  Screen_Cols : Display_Cols;
  oldx, oldy : byte;

procedure SendStr (ss : string);
var i : byte;
begin
 for i := 1 to length(ss) do
 sendchar(ss[i]);
 sendchar(^M);
end;

function WaitferStr
        (lookfor : string; howlong : integer; echo , itmatters : boolean) : boolean;
var sedit,doneline : boolean;
    ss,whatitsed : string;
    i : integer;
 begin
 ss := lookfor + #13#10; {cr + lf}
 sedit := false;
 doneline := false;
 whatitsed := '';
 for i := 1 to 1000 {wait # secs/howlong} do
 begin
   delay(howlong);
   ch := getchar;
   if ch <> #0 then
   begin
     if echo then write(ch);
     whatitsed := whatitsed + ch;
     if (ch = #10) and (whatitsed[length(whatitsed)-1] = #13) then
       doneline := true;
     if doneline then
     begin
       if upper(whatitsed) = upper(ss) then sedit := true
         else
           begin
           whatitsed := '';
           sedit := false;
           doneline := false;
           end;
       if sedit then i := 1000; {finished}
     end; {if doneline+sedit}
   end;   { if ch <> #0 }
 end; { timed loop }
 If (not sedit) and (itmatters) then begin fwriteln(''); fwriteln('Modem timed out while looking for: "'+lookfor+'"!');end;
 Waitferstr := sedit;
end;

function Show1Str : string;
var zt,done : boolean; { zt = half done }
   tried : integer;
begin
 Show1str := '';
 zt := false;
 done := false;
 tried := 0;
 repeat
   delay(10);
   inc(tried);
   ch := getchar;
   if ch <> #0 then
   begin
    show1str := show1str + ch;
    write(ch);
   end; { if not <> # }
   if ((zt = true) and (ch = #10)) then done := true { CRLF = done }
     else zt := false;
   zt := (ch = #13);
 until done or (tried > 1000);
end;

function waitshow(lay : integer) : boolean;
var x : integer;
begin
 waitshow := false;
 for x := 1 to 1000 do
 begin
 delay(lay);
 ch :=getchar;
 if ch <> #0 then begin write(ch); waitshow := true; end;
 end;
end;

function Get1Str(timee : byte) : string;
var last : char;
    incz : integer;
    itwuz : string;
begin
itwuz := '';
repeat
 inc(incz);
 ch := getchar;
 if ch <> #0 then
 begin
  itwuz := itwuz + ch;
  if (ch=#10) and (last=#13) then {finished}
   exit;
  last := ch;  
 end;
 until incz > (timee*1000);
 get1str := itwuz;
 { if it went all way, we didnt get a string, oh well}
end;

procedure Dialit;
var ss : string;
    loopz : integer;
    sn : boolean;
begin
 ss := '';
 delay(1000); { 1 second delay }
 fwriteln('');
 fwriteln('Now Dialing '+prgname+'...');
 sendstr(^M+user.dialing+fone);
 sn := false;
 for loopz := 30 downto 1 do {up to five lines}
 begin   {move back}
  writeat(1,wherey,yellow,black,'Countdown: ['+int_to_str(loopz)+']');
  ss := Get1Str(1);
  if ss[1] <> #0 then
  begin
     if upper(ss) = 'BUSY' then begin fwriteln(prgname+' is BUSY.'); Loopz := 1; Sn := true; end;
     if upper(ss) = 'NO CARRIER' then begin fwriteln('No carrier given.'); Loopz := 1; Sn := true; end;
     if upper(ss) = 'NO DIALTONE' then begin fwriteln('No Dialtone Found.'); Loopz := 1; Sn := true; end;
     if loopz > 3 then sendchar(^M); {press enter} 
  { TEST }
  write('MODEM RESPONSE: '+ss);
  { TEST }
  end; {if not nul string sent}
 end;
 if sn {something was sent} then tempmessagebox(1,3,lightred,black,2,' No response in attempt to DIAL.  Press ENTER ');
end;


procedure Welcomescrn;
begin
 clrscr;
 offcursor;
 speed := 0;
 growfbox(5,1,74,3,red, black, 3);
 writeat(7,2,white,black,' Welcome to the '+prgname+' Terminal Program (c) 1990 by C. Kaitila ');
 {uncrunch?}
 writecenter(4,white,black,'Press Esc to Access the Pull Down MENU System, ALT-X Quits Immediately.');
 writecenter(6,yellow,black,'TITLE SCREEN HERE List some features here..  will look good!');
 writecenter(9,white,black,'Written by: C.Kaitila, COPRIGHTS ALL OVER (I''ll copy framework''s big one)');
 writecenter(11,cyan,black,'TEST VERSION');
 delaykey(10000);
 oncursor;
end;

procedure Goodbyescrn;
begin
 clrscr;
 offcursor;
 gotoxy(1,4);
 fbox(1,1,75,3,red, black, 3);
 writeat(3,2,white,black,' Thanx for using the '+prgname+' Terminal Program (c) 1990 by C. Kaitila ');
 oncursor;
end;


      {$F+}
      Procedure Menu_Help(Var ChM:Char;Major,Minor : byte);
      var Ch : char;
      begin       
         If ChM = F1 then
         begin
            MkWin(20,7,60,15,white,red,1);
             case Major of
             1 : case Minor of
                      1 : begin
            WriteAT(22,9,white,red, 'This option will EXIT the program,');
            WriteAT(22,10,white,red,'and Hang Up if needed.  You will be');
            WriteAT(22,11,white,red,'brought back to where you were when');
            WriteAT(22,12,white,red,'this program was loaded.');
            WriteAT(22,13,white,red,'(either at a menu or DOS)');
                          end;
                      2 : begin
            WriteAT(22,9,white,red, 'Use this option to TEMPORARILY exit');
            WriteAT(22,10,white,red,'to DOS, to do various things.  For');
            WriteAT(22,11,white,red,'example, you could format some disks,');
            WriteAT(22,12,white,red,'or edit a file.  You need only type');
            WriteAT(22,13,white,red,'EXIT to return; CLUB is in memory.');
                          end;
                      3 : begin
            WriteAT(22,9,white,red, 'This option will put you in the');
            WriteAT(22,10,white,red,'configuration section.  There you can');
            WriteAT(22,11,white,red,'input your Name, Password, what type');
            WriteAT(22,12,white,red,'of modem you are using, and other');
            WriteAT(22,13,white,red,'general information.');
                          end;
                 end; { Case Minor }

             2 : case Minor of
                      1 : begin
            WriteAT(22,9,white,red, 'Use this option to SEND a file to the');
            WriteAT(22,10,white,red,'host.  You should tell the host that');
            WriteAT(22,11,white,red,'you are going to send a file firt so');
            WriteAT(22,12,white,red,'it knows what to do with the file.');
            WriteAT(22,13,white,red,'Be sure you know where the file is.');
                          end;
                      2 : begin
            WriteAT(22,9,white,red, 'This option is to RECEIVE a file from');
            WriteAT(22,10,white,red,'the host.  This is called DOWNLOADing.');
            WriteAT(22,11,white,red,'When prompted, you should input the');
            WriteAT(22,12,white,red,'path of the disk you wish to have the');
            WriteAT(22,13,white,red,'put onto.');
                          end;
                      3 : begin
            WriteAT(22,9,white,red, 'Use this option to look around your  ');
            WriteAT(22,10,white,red,'disk drives to, for example, look for');
            WriteAT(22,11,white,red,'a file or to find out how much space');
            WriteAT(22,12,white,red,'is left on your Hard Drive.  This is');
            WriteAT(22,13,white,red,'much like the DOS command, DIR.');
                          end;
                 end; { Case Minor }

              3 : case Minor of
                      1 : begin
            WriteAT(22,9,white,red, 'Chosing this will DIAL the system you');
            WriteAT(22,10,white,red,'want to connect to.  If the line is');
            WriteAT(22,11,white,red,'BUSY, it will be re-dialed until you');
            WriteAT(22,12,white,red,'abort the procedure, or a connection');
            WriteAT(22,13,white,red,'has been made.');
                          end;
                      2 : begin
            WriteAT(22,9,white,red, 'This will HANG UP the phone, and thus');
            WriteAT(22,10,white,red,'disconnect you from the host.  Typing');
            WriteAT(22,11,white,red,'Alt-X or Exiting the program will');
            WriteAT(22,12,white,red,'automatically hang up for you, but');
            WriteAT(22,13,white,red,'this may be used if wanted.');
                          end;
                 end; { Case Minor }
            end; { major }
            Ch := GetKey;
            RmWin;
         end;
      end;
      {$F-}

{$F+}
procedure IdleKeybd;
begin
end;
{$F-}

   Procedure MakeScreenInput;
   begin
      mkwin(1,1,80,25,yellow,black,2);
      ClearText(2,2,79,24,white,black);
       With Screen_Cols do
       begin
            WriteCenter(25,TextF,back,prgname+' Comm Program - (c) C. Kaitila');
            WriteCenter(1,HeadF,back,' Configiration Screen - F10 Save - Esc Exit ');
            WriteAt(9,3,TextF,back,'User Name:');
            WriteAT(9,4,TextF,back,'Password:');
            WriteAT(9,5,TextF,back,'Modem Baud:');
            WriteAT(9,6,TextF,back,'Comm Port:');
            WriteAT(9,7,TextF,back,'Dial String:');
            writeAT(9,8,TextF,back,'Init String:');
            writecenter(10,7,0,'Use arrow keys to move around');
            writecenter(11,7,0,'Ins, Del, Home, End work anywhere');
            writecenter(12,7,0,'Alt-E: Erase All, Alt-D: Delete Current field');
            writecenter(19,yellow,black,'Current Field Description:');
       end;
   end; {of proc Set_Screen}

   Procedure SetInputFields;
   {}
   var I : Integer;
   begin
       Create_Tables(1);
       Activate_Table(1);
       With Screen_Cols do
            Define_Colors(FieldHiF, FieldHiB, FieldLoF, FieldLoB, MsgF, MsgB);
       Allow_Esc(true);
       Create_Fields(6);
       Add_Field(1,  6,2,6,2,    22,3);
       Add_Field(2,  1,3,1,3,    22,4);
       Add_Field(3,  2,4,2,4,    22,5);
       Add_Field(4,  3,5,3,5,    22,6);
       Add_Field(5,  4,6,4,6,    22,7);
       Add_Field(6,  5,1,5,1,    22,8);
       String_Field(1, user.name,     replicate(30,'*'));
       Add_Message(1,0,20,'Enter your Name to be used while online at the '+prgname);
       String_Field(2, user.password, replicate(30,'*'));
       Add_Message(2,0,20,'This is the password that is sent to the host.  Security.');
       Integer_Field(3, user.baud,     '######',0,19200);
       Add_Message(3,0,20,'Enter the maximum BAUD rate at which your MODEM is capable.');
       byte_Field(4, user.Com,      '#',1,4);
       Add_Message(4,0,20,'Enter the Communications port # the MODEM is hooked up to.' );
       string_field(5, user.dialing,  '!!!!!!!!!!!!!!!!!!!!!!!!!');
       Add_Message(5,0,20,'Enter the Dialing String, usually ATDP:pulse or ATDT:tone' );
       string_field(6, user.initstr,  '!!!!!!!!!!!!!!!!!!!!!!!!!');
       Add_Message(6,0,20,'Enter the string sent during the initialization of the modem.' );
   end; {of proc Set_Fields}


procedure Unsetup;
begin
 Hangup;
 Com_Deinstall;
 If SettingsChanged then
 begin
  write('Saving configuration..');
  Assign(ConfigFile,'CLUB.CFG');
  {$I-}
  rewrite(configfile);
  write(configfile,user);
  {$I+}
  for x := 1 to 23 do
   begin
   write('< ');
   delay(30);
   write('');
   end;
   write(' ');
  if ioresult > 0 then begin writeln('Error writing config changes to disk!'); halt; end;
 end;
end;

procedure ModemSetup;
var anyerrors : word;
    Hmm : boolean;
begin
 { Modem Setup }
 clrscr;
 Com_Install(user.com, AnyErrors);
 if anyerrors > 0 then {hmm} ;
 Setmodem;
 setparam(user.com,user.baud,false);
 sendstr(user.initstr);
 if not waitferstr('OK',5,false,false) then
  tempmessagebox(1,3,lightred,black,2,' No "OK" returned when init string was sent. Press ENTER ');
 Dialit;
end;


Procedure SetupMenu;
begin
    Fillchar(TheMenu,sizeof(TheMenu),#0);    {Empty the array}
    TheMenu[1] := '\Program';
    TheMenu[2] := ' Exit Program  ';
    TheMenu[3] := ' Shell to DOS  ';
    TheMenu[4] := ' Configuration ';
    TheMenu[5] := '\File';
    TheMenu[6] := ' Send          ';
    TheMenu[7] := ' Recieve       ';
    TheMenu[8] := ' Directory     ';
    TheMenu[9]  :='\Communicate';
    TheMenu[10] :=' Dial Club     ';
    TheMenu[11] :=' Hang Up       ';
    TheMenu[12]  :='\Help Me!';
    TheMenu[13] :=' Modems        ';
    TheMenu[14] :=' This Program  ';
    TheMenu[15] := '\\';
    Major := 1;
    Minor := 3;
    PTTT.Hook := Menu_Help;
    With PTTT do
    begin
        Style := 1;
        TopX := 7;
        TopY := 2;
        Gap :=  7;
        AlwaysDown := true;
    end;
end;

procedure Configuration;
begin
       With Screen_Cols do
            If BaseOfScreen = $B800 then {color}
            begin
                TextF    := white;
                Back     := Blue;
                MsgF     := yellow;
                MsgB     := red;
                FieldHiF := white;
                FieldHiB := red;
                FieldLoF := Lightgray;
                FieldLoB := black;
                BoxF     := lightcyan;
                HeadF    := white;
            end
            else
            begin
                TextF    := lightgray;
                Back     := black;
                MsgF     := white;
                MsgB     := black;
                FieldHiF := black;
                FieldHiB := lightgray;
                FieldLoF := white;
                FieldLoB := black;
                BoxF     := white;
                HeadF    := white;
            end;
 SettingsChanged := true;

 if not carrier then modemsetup; {new params!!!}

 MakeScreenInput;
 SetInputFields;
 With Table[CurrentTable]^.ITTT do
  ErrorLine := 21;
 Process_Input(1);
 Dispose_Fields;
 rmwin; {the screen}
end;

procedure SendFile;
begin
 tempmessagebox(3,1,lightcyan,black,3,'Send File: UNFINISHED');
end;

procedure RecieveFile;
begin
 tempmessagebox(3,1,lightcyan,black,3,'Recieve File: UNFINISHED');
end;

procedure DoDirectory;
begin
 tempmessagebox(3,1,lightcyan,black,3,'Directory stuff: UNFINISHED');
end;

procedure ModemHelp;
begin
 tempmessagebox(1,15,white,black,2,'I''ll give LOTS of verbose info for idiots');
end;

procedure ProgHelp;
begin
 tempmessagebox(1,15,white,black,2,'I''ll give LOTS of verbose info for idiots');
end;

procedure CheckMenuChoice;
var x,y : integer;
begin
 case Major of
 1 : case Minor of
          1 : begin
               GoodbyeScrn;
               Unsetup;
               Halt;
              end;
          2 : begin
               savescreen(1);
               clrscr;
               writeat(1,1,lightgreen,black,'Type [----] to return!');
               clickwrite(7,1,white,black,'EXIT');
               gotoxy(1,2);
               oncursor;
               SwapVectors;
               Exec(Getenv('COMSPEC'),'');
               SwapVectors;
               restorescreen(1);
               disposescreen(1);
               offcursor;
              end;
          3 : begin
               Configuration;
              end;
     end; { Case Minor }

 2 : case Minor of
          1 : begin
               SendFile;
              end;
          2 : begin
               RecieveFile;
              end;
          3 : begin
               DoDirectory;
              end;
     end; { Case Minor }

 3 : case Minor of
          1 : begin
               DialIt;
              end;
          2 : begin
               clrscr;
               fwriteln('>> Hanging Up <<');
               Hangup;
              end;
     end; { Case Minor }

 4 : case Minor of
          1 : begin
               ModemHelp;
              end;
          2 : begin
               ProgHelp;
              end;
     end; { Case Minor }

 end; { Case Major }
end;

procedure termloop; forward;

procedure MenuMaker;
begin
     oldx := wherex;
     oldy := wherey;
     offcursor;
     MkWin(7,1,73,1,white,black,0);
     writecenter(1,lightcyan,blue,'   MENU: F1 for Help -- Esc to Return     Modem Status:           ');
     If carrier then writeAT(64,1,white,blue,'ONLINE') else
        writeAT(64,1,white,blue,'OFFLINE');
     Pull_Menu(TheMenu,Major,Minor);
     if major <> 0 then CheckMenuChoice;
     RmWin;
     oncursor;
     gotoxy(oldx,oldy);
end;

procedure TermLoop;
var quitit : boolean;
begin
 quitit := false;
 clrscr;
 fbox(1,1,27,4,yellow,red,3);
 writeat(3,2,white,red,' Ready to Communicate');
 writeat(3,3,7,red   , 'Esc: MENU - Alt-X: Quit');
 gotoxy(1,5);
 repeat {main}
     If keypressed then
     begin
      ch := getkey;
      case upcase(ch) of
       Esc : begin
               if not carrier then
                begin
                { write modem status? nah }
                end;
              menumaker;
             end; { escpressed }
       AltX: quitit := true
       else sendchar(ch); {send it if its not Esc or AltX}
      end; {case}
     end; {if keypressed}
     ch := getchar;
     if ch <> #0 then
      write(ch);
 until quitit = true;
end;



procedure newconfigs;
begin
 {$I-}
 fwriteln('Making NEW configs with defaults...');
 rewrite(configfile);
 with user do
 begin
  Name := 'User Name';
  Password := 'Password';
  Baud := 1200;
  com := 1;
  dialing := 'ATDT';
  initstr := 'ATZ';
 end {with};
 write(configfile,user);
 {$I+}
 if ioresult > 0 then begin writeln('Error making new CLUB.CFG configs!'); Halt; end;
 reset(configfile);
end;

procedure LoadConfiguration;
begin
 Assign(Configfile,'CLUB.CFG');
 {$I-}
 Reset(configfile);
 read(configfile,user);
 {$I+}
 if ioresult > 0 then newconfigs;
end;


procedure SetUpAll;
begin
    textcolor(7);
    textbackground(0);
    { Assign_Idle_Hook(IdleKeybd); <-- None 4 now }
    SetupMenu;
    SettingsChanged := false;
    LoadConfiguration;
    ModemSetup;
end;

procedure StartUp;
begin
 TermLoop;
end;

{ ** MAIN ** }
begin
    WelcomeScrn;
    SetupAll;
    StartUp;
    { if Alt-X: }
      GoodbyeScrn;
      Unsetup; { save configs etc }
end.

