{$M 6024,0,5000}     {Make REAL small}
                     { min: 1024,0,100}
program tsrtest;     {TSR shell for Turbo Pascal}

uses dos,crt,winttt5,keyttt5,fastttt5,strnttt5;

{N.b. adjust compiler memory directive for changes.}

type       byte2   = array[1..2] of byte;
           byte16  = array[1..16] of byte;

const
           hotkey  = $46;               {Hot mother scan code             }
           vid_seg = $B000;             {monochrome ttl screen            }
           vid_off = 141;               {top right screen location        }
         attribute = 112;               {show clock in reverse video      }
var
z,wait,oldx,oldy   : integer;
ch                 : char;
scancode,x         : byte;
exitvector,
  new09vector,
  old09vector      : pointer;
regs               : registers;
b                  : byte2;
scr_array,
  old_array        : byte16;
note               : string;


{$F+}
procedure my_exit;
{$F-}
begin
setintvec($09,old09vector);  {turns off my kbd intercept routine by       }
                             {reseting 09 interrupt to aim at its own code}
if (exitcode <> 0) or (erroraddr <> nil) then
     begin
     assign(output, '');
     rewrite(output);
     writeln(#7);
          begin
          write('Critical Error #',exitcode,' at address ');
          writeln(seg(erroraddr^),':',(ofs(erroraddr^)));
          end;
     end;
exitproc := exitvector;
end;

procedure DeInstall;
begin
 my_EXIT;
 writeln('Program now DE-INSTALLED.');
 halt;
end;


procedure newint09handler(Flags,cs,ip,ax,bx,cx,dx,si,di,ds,es,bp : word);
interrupt;

  procedure Cool_Dir_Writes;
  begin
    for z := 1 to 16 do               {get what is there now              }
    old_array[z] := mem[vid_seg:vid_off + z];
    for z := 1 to 16 do               {write screen array to screen memory}
    mem[vid_seg:vid_off + z] := scr_array[z];
    for z := 1 to 16 do               {then restore screen as it was      }
    mem[vid_seg:vid_off + z] := old_array[z];
  end;

begin
  inline($9C);                        {pushf                              }
  scancode := port[$60];              {check scan code of pressed key     }
  if scancode = hotkey then           {if it's our hotkey then GO!!!      }

  {   Here begins what you want to run resident.   }
  {   You can't use Pascal code that calls DOS.    }

  begin { MAIN }
    { CANNOT do a gotoxy.. }
    wait := 5000;
    mkwin(10,10,40,20,yellow,red,3);
    writeln;
    writeat(12,11,15,red,'     ++> MamaTSR <++');
    writeat(12,12,15,red,'thIS is a TSR PROgrAm, And');
    writeat(12,13,15,red,'As yOU cAN paINLy SEE.. It');
    writeat(12,14,15,red,'wORkS!  iN tP5.5!! wOWEe!!');
    write;
    repeat
     dec(wait);
     writeat(12,16,14,red,'Timeout: '+int_to_str(wait)+'  ');
    until (wait<1) or keypressed;
    { keypressed dont work!! }

    {if keypressed then                                             }
    {begin                                                          }
    { writelN('+++++++++ KEY WAS PRESSED +++++++++');               }
    { ch := readkey;                                                }
    { case upcase(ch) of                                            }
    {  'X' : DeInstall;                                             }
    {  'Q' : my_exit;                                               }
    {  ' ' : exit;                                                  }
    {  end;                                                         }
    {end                                                            }
    { ELSE                                                          }
    {writeat(1,1,0,red,'+++++++++ KEY WAS NOT PRESSED! +++++++++'); }

    sound(500);
    delay(200);
    nosound;
   rmwin;
   sound(200);
   delay(200);
   nosound;
  end; 

  {   Here ends what you want to run resident.     }

  {now comes hard job of switching control back to real 09 handler }
  {the inline code is credited to somebody named Lane Ferris       }
  inline(
     $9D/                   {POPF              ;begin exit from handler    }
     $A1/> old09vector+2/   {MOV AX,KBD_VEC+2  ;get seg addr of old 09     }
     $8B/$1E/> old09vector/ {MOV BX,KBD_VEC    ;get off of old 09 handler  }
     $87/$5E/$0E/           {XCHG BX,[BP+14]   ;restore old offset         }
     $87/$46/$10/           {XCHG AX,[BP+16]   ;ditto segment -- put in ax }
     $8B/$E5/               {MOV SP,BP         ;undo what TP did with INTR }
     $5D/                   {POP BP            ;pop back all the registers }
     $07/                   {POP ES}
     $1F/                   {POP DS}
     $5F/                   {POP DI}
     $5E/                   {POP SI}
     $5A/                   {POP DX}
     $59/                   {POP CX}
     $CB);                  {RETF              ;works to jmp to old 09-uses}

end;

procedure tsr;
begin
keep(exitcode);
end;

procedure start;
begin
if (paramstr(1)='X') or (paramstr(1)='x') then DeInstall;
getintvec($09,old09vector);           {save the machine's 09 int handler  }
setintvec($09,@newint09handler);      {aim 09 int calls to our int handler}
exitvector := exitproc;
exitproc := @my_exit;
end;

begin
start;
Clrscr;
growFBOX(1,1,43,3,15,0,2);
writeAT(2,3,11,0,'ChristerTSR Active! - Tap [Scroll Lock] to invoke!');
writeln;
writeln;
writeln;
tsr;
end.
