{$R-,S-,I-,D-,F+,V-,B-,N-,L+ }
{$M 65500,0,0 }

unit windows;

interface

uses gentypes,gensubs,crt,subs1,configrt,fastttt5,strnttt5;

var winds:array [0..2] of windowrec;
    split,inuse:integer;

procedure getcoor;
procedure usewind (n:byte);
procedure setwind (n:byte; nx1,ny1,nx2,ny2:byte);
procedure initwind (n,nx1,ny1,nx2,ny2,ncolor:byte);
procedure top;
procedure bottom;
procedure wholescreen;
procedure drawsplit;
procedure initwinds;
procedure unsplit;
procedure splitscreen (v:byte);
procedure setoutlock (b:boolean);
procedure bottomline;

implementation

procedure getcoor;
begin
  with winds[inuse] do begin
    cx:=wherex;
    cy:=wherey;
    if cy<1 then cy:=1;
    if cy>(y2-y1)+1 then cy:=(y2-y1)+1
  end
end;

procedure usewind (n:byte);
begin
  getcoor;
  inuse:=n;
  with winds[n] do begin
    window (x1,y1,x2,y2);
    gotoxy (cx,cy);
    textcolor (color);
    textbackground (0);
    lasty:=y2-y1+1
  end
end;

procedure setwind (n:byte; nx1,ny1,nx2,ny2:byte);
var i:integer;
begin
  i:=inuse;
  usewind(n);
  with winds[n] do begin
    x1:=nx1;
    y1:=ny1;
    x2:=nx2;
    y2:=ny2
  end;
  usewind(n);
  if n<>i then usewind(i)
end;

procedure initwind (n,nx1,ny1,nx2,ny2,ncolor:byte);
begin
  with winds[n] do begin
    x1:=nx1;
    y1:=ny1;
    x2:=nx2;
    y2:=ny2;
    cx:=1;
    cy:=1;
    color:=ncolor
  end
end;

procedure top;
begin
  usewind (1)
end;

procedure bottom;
begin
  usewind (2)
end;

procedure wholescreen;
begin
  usewind (0)
end;

procedure drawsplit;
var cnt:integer;
begin
  usewind (0);
  textcolor (splitcolor);
  gotoxy (1,split);   { speed }
  for cnt:=0 to 79 do fwrite ({usr,}chr(196));
  bottom
end;

procedure initwinds;
begin
  splitmode:=false;
  initwind (0,1,1,80,25,splitcolor);
  initwind (2,1,1,80,23,normbotcolor);
  split:=0;
  inuse:=0;
  bottom
end;

procedure unsplit;
var y:integer;
begin
  if not splitmode then exit;
  if inuse=2
    then y:=wherey
    else y:=winds[2].cy;
  y:=y+split;
  setwind (2,1,1,80,23);
  setwind (1,1,1,80,split);
  top;
  clrscr;
  splitmode:=false;
  bottom;
  gotoxy (wherex,y)
end;

procedure splitscreen (v:byte);
var x,y:integer;
begin
  if splitmode then unsplit;
  x:=wherex;
  y:=wherey-v;
  splitmode:=true;
  split:=v;
  drawsplit;
  initwind (1,1,1,80,split-1,normtopcolor);
  setwind (2,1,split+1,80,23);
  top;
  clrscr;
  bottom;
  gotoxy (x,y)
end;

procedure setoutlock (b:boolean);
begin
  modemoutlock:=b;
  if b
    then winds[2].color:=outlockcolor
    else winds[2].color:=normbotcolor;
  if inuse=2 then usewind (2)
end;

procedure bottomline;
var o:integer;
var baud:string;

begin
  if inuse=0 then exit;
  o:=inuse;
  wholescreen;
  if timelock then settimeleft (lockedtime);
  cleartext (1,24,80,25,black,statlinecolor);
  statlinecolor:=green;
  case Status_Line_Mode of
  
  1 :  begin
       {  Name of Person.......23  Lvl:101FL:101GL:101UL:15DL:15Post:100Pts:100 }
       writeat (1,24,black,statlinecolor,' '+padcenter(unam,23,'')+'  Lvl:'+strr(ulvl)+
                'FL:'+strr(urec.udlevel)+'GL:'+strr(urec.gflevel)+
                'UL:'+strr(urec.uploads)+'DL:'+strr(urec.downloads)+'Post:'+strr(urec.nbu)+'Pts:'+strr(urec.udpoints));
       {  User Note Here.......23  [xInxOutNxtTrpTimSysCHAT]TL:666Cht:Yes2400} 
       writeat (1,25,black,statlinecolor,' '+padcenter(urec.note,23,'')+
                 '  [xInxOutNxtTrpTimSysCHAT]TL:'+
                 strr(timeleft)+'Cht:'+Little_Avail_Str+'');
       if timelock then settimeleft (lockedtime);
       str (baudrate,baud);
       if local then baud:='Local'
          else
          baud := baud[1] + baud[2];  {ie 12,24,96,19,38}
       writeat (76,25,0,statlinecolor,baud);
     {  if useqr then begin
        with urec do
        qr:=qrmultifactor*(urec.uploads+urec.nbu)-urec.downloads;
        write (usr,'QR:',qr,'  ');
       end;  }
       if timelock then     writeat (47,25,14,statlinecolor,'Tim');  
       if modeminlock then  writeat (30,25,14,statlinecolor,'xIn');
       if modemoutlock then writeat (34,25,14,statlinecolor,'xOut');
       if tempsysop then    writeat (51,25,14,statlinecolor,'Sys');
       if texttrap then     writeat (43,25,14,statlinecolor,'Trp');
       if sysnext then      writeat (39,25,14,statlinecolor,'Nxt');
       if chatmode then     writeat (55,25,29,statlinecolor,'CHAT');
    end; { if Mode is 1 }

  2 : begin
      writeat (1,24,black,statlinecolor,' '+padcenter(unam,23,'')+'  Phone:('+urec.phonenum[1]+
              urec.phonenum[2]+urec.phonenum[3]+')'+urec.phonenum[4]+urec.phonenum[5]+
              urec.phonenum[6]+'-'+urec.phonenum[7]+urec.phonenum[8]+urec.phonenum[9]+urec.phonenum[10]+
              'UL:'+strr(urec.upk)+'kDL:'+strr(urec.downk)+'kTot:'+real_to_str(urec.totaltime,2)+' mins');
      writeat (1,25,black,statlinecolor,' '+padcenter(urec.note,30,'')+'  LO:'+datestr(laston)+
              'PW:'+padcenter(urec.password,17,'')+'Times:'+strr(urec.numon));
      end; { if Mode is 2 }

  end; { case Mode }
  usewind (o);
end;

begin
end.

