program convert;
{$M 3000,0,0}

uses dos;

type
     lstr=string[80];
     mstr=string[30];

     arearecnew=record
       name,xmodemdir:lstr;
       sponsor,areapw:mstr;
       groupfn:lstr;
       usegroup:boolean;
       level:integer;
       upload,download:boolean
     end;

     arearecold=record
       name,xmodemdir:lstr;
       sponsor,areapw:mstr;
       level:integer;
       upload,download:boolean;
     end;

var fnew:file of arearecnew;
    fold:file of arearecold;
    newf:arearecnew;
    oldf:arearecold;
    cnt:integer;

function numareas:integer;
begin
  numareas:=filesize (fold);
end;

procedure seekareafileold (n:integer);
begin
  seek (fold,n-1);
end;

procedure seekareafilenew (n:integer);
begin
  seek (fnew,n-1);
end;

begin
  writeln (' -- Be Sure To Back-Up Your ''AREADIR'' File! --');
  writeln;
  writeln ('-- Press <C/R> To Continue, CTRL-BRK To Quit --');
  readln;
  assign (fnew,'AREADIR.NEW');
  assign (fold,'AREADIR');
  rewrite (fnew);
  reset (fold);
  for cnt:=1 to numareas do begin
    seekareafileold (cnt);
    read (fold,oldf);
    seekareafilenew (cnt);
    newf.name:=oldf.name;
    newf.xmodemdir:=oldf.xmodemdir;
    newf.sponsor:=oldf.sponsor;
    newf.areapw:=oldf.areapw;
    newf.groupfn:='';
    newf.usegroup:=false;
    newf.level:=oldf.level;
    newf.upload:=oldf.upload;
    newf.download:=oldf.download;
    write (fnew,newf);
  end;
  close (fnew);
  close (fold);
  exec (getenv('COMSPEC'),' /C COPY AREADIR.NEW AREADIR ');
end.