Program CIBC_Club_Dialer;

{$M 16000,0,16000}
{$V-} { string checking off }

{ room for dos shell? }

Uses Dos, Crt, Printer, MODEM, StrnTTT5, MiscTTT5, IOTTT5, FastTTT5, WinTTT5, KeyTTT5, PullTTT5;

{ CIBC Club User Interface with "MamaMenu v1.0" }

const fone = '438-7570';  {what to dial}
      prgname = 'CIBC';

const BUSYresponces : array[1..3] of string[15] =
                      ('BUSY','NO CARRIER','NO DIALTONE');

type settings = record
     Name : string;
     Password : string;
     Baud : integer;
     Com : byte;
     Dialing : String;
     InitStr : string;
     end;

   Display_Cols = record
                      TextF    : byte;
                      Back     : byte;
                      MsgF     : byte;
                      MsgB     : Byte;
                      FieldHiF : byte;
                      FieldHiB : Byte;
                      FieldLoF : Byte;
                      FieldLoB : Byte;
                      BoxF     : Byte;
                      HeadF    : Byte;
                  end;

CONST crlf = #13#10;


var
  TheMenu : Pull_Array;   {Array holding the menu definitions}
  Major,Minor : byte;
  Ch : char;
  X : integer;
  SettingsChanged : boolean;
  Configfile : file of settings;
  user : settings;
  Screen_Cols : Display_Cols;
  oldx, oldy : byte;
  POut,FOut : boolean;
  FOutFile : Text;
  FoutName : string[60];

procedure SendStr (ss : string);
var i : byte;
begin
 for i := 1 to length(ss) do
 sendchar(ss[i]);
 sendchar(^M);
end;

function WaitferStr
        (lookfor : string; howlong : integer; echo , itmatters : boolean) : boolean;
var sedit,doneline : boolean;
    ss,whatitsed : string;
    i : integer;
 begin
 ss := lookfor + #13#10; {cr + lf}
 sedit := false;
 doneline := false;
 whatitsed := '';
 for i := 1 to 1000 {wait # secs/howlong} do
 begin
   delay(howlong);
   ch := getchar;
   if ch <> #0 then
   begin
     if echo then write(ch);
     whatitsed := whatitsed + ch;
     if (ch = #10) and (whatitsed[length(whatitsed)-1] = #13) then
       doneline := true;
     if doneline then
     begin
       if upper(whatitsed) = upper(ss) then sedit := true
         else
           begin
           whatitsed := '';
           sedit := false;
           doneline := false;
           end;
       if sedit then i := 1000; {finished}
     end; {if doneline+sedit}
   end;   { if ch <> #0 }
 end; { timed loop }
 If (not sedit) and (itmatters) then begin fwriteln(''); fwriteln('Modem timed out while looking for: "'+lookfor+'"!');end;
 Waitferstr := sedit;
end;

function Show1Str : string;
var zt,done : boolean; { zt = half done }
   tried : integer;
begin
 Show1str := '';
 zt := false;
 done := false;
 tried := 0;
 repeat
   delay(10);
   inc(tried);
   ch := getchar;
   if ch <> #0 then
   begin
    show1str := show1str + ch;
    write(ch);
   end; { if not <> # }
   if ((zt = true) and (ch = #10)) then done := true { CRLF = done }
     else zt := false;
   zt := (ch = #13);
 until done or (tried > 1000);
end;

function waitshow(lay : integer; var Sss : string) : boolean;
var x : integer;
begin
 { Sss is the LAST string given }
 waitshow := false;
 for x := lay downto 1 do
 begin
   if keypressed then begin writeat(3,3,black,blue,'Aborted.'); Delay(1000); Exit; end;
   writeat(3,3,white,blue,'Waiting...: '+int_to_str(x)+' ');
   delay(1000);
   ch :=getchar;
   if ch = #13 then ch := #0; { replace new line with 1 space }
   if ch = #10 then ch := ' ';
   if ch <> #0 then begin Sss := Sss + ch; waitshow := true; end;
   { if (sss[(length(sss)-1)] + sss[length(sss)]) = CRLF then Sss := ''; }
   sss := extractwords(WordCnt(sss),2,sss); { SSS := its last 2 words }
   if upper(extractwords(1,1,sss)) = 'BUSY' then sss := 'BUSY'; { if busy only last 1 }
   if (upper(sss) = BusyResponces[1]) then x := 1;
   if (upper(sss) = BusyResponces[2]) then x := 1;
   if (upper(sss) = BusyResponces[3]) then x := 1;
   if (upper(sss[1]+sss[2]+sss[3]) = 'CON') then x := 1;
 end;
end;

function RepeatIt(Resp : string) : boolean;
var cc : char;
begin
 RepeatIt := false;
 If (NOT Carrier) or
    (Upcase(resp[1]) + Upcase(resp[2]) +
     Upcase(resp[3])) <> 'CON') then     { Ask this only if we didnt get on }
  begin
    writeat(3,5,7,blue,'Try DIALING again? [y/n] ');
    oncursor;
    gotoxy(29,5);
    cc := getkey;
    writeat(29,5,yellow,blue,cc);
    if upcase(cc) = 'Y' then RepeatIt := true;
  end;
end;

procedure Dialit;
var stored : string;
    cc : char;
begin
 writeat(1,2,yellow,black,' Modem Initialized');
 delay(500); { 1/2 second delay }
 OFFcursor;
 mkwin(1,1,30,8,green,blue,3);             {CIBC}
 writeat(2,2,white,blue,'Ĵ Now Dialing '+prgname+' ');
 writeat(2,6,green,blue,'');
 writeat(3,7,7,blue,    '   Press [SPACE] to Abort');
 sendstr(^M+user.dialing+fone);
 if not waitshow(25,Stored) then
   tempmessagebox(1,9,lightred,black,2,' No response in attempt to DIAL.  Press ENTER ')
 else
   begin
    writeat(3,4,yellow,blue,'Modem Responce: '+stored);
    if RepeatIt(stored) = true then begin RmWin; Dialit; end;
   end;
 RmWin;
 ONcursor;
end;


procedure Welcomescrn;
begin
 clrscr;
 offcursor;
 speed := 0;
 growfbox(5,1,74,3,red, black, 3);
 writeat(7,2,white,black,' Welcome to the '+prgname+' Terminal Program (c) 1990 by Mr. C. Kaitila ');
 {uncrunch?}
 writecenter(4,white,black,'Press F10 to Access the Pull Down MENU System, ALT-X Quits Immediately.');
 writecenter(6,yellow,black,'TITLE SCREEN HERE List some features here..  will look good!');
 writecenter(9,white,black,'Written by: Mr. C. Kaitila, COPYRIGHTS ALL OVER (I''ll copy framework''s big one)');
 writecenter(11,cyan,black,'TEST VERSION');
 delaykey(10000);
 oncursor;
end;

procedure Goodbyescrn;
begin
 clrscr;
 offcursor;
 gotoxy(1,4);
 fbox(1,1,75,3,red, black, 3);
 writeat(3,2,white,black,' Thanx for using the '+prgname+' Terminal Program (c) 1990 by C. Kaitila ');
 oncursor;
end;


      {$F+}
      Procedure Menu_Procs(Var ChM:Char;Major,Minor : byte);
      var Ch : char;
      begin
         If ChM = F1 then
         begin
            MkWin(20,7,60,15,white,red,1);
             case Major of
             1 : case Minor of
                      1 : begin
            WriteAT(22,9,white,red, 'This option will EXIT the program,');
            WriteAT(22,10,white,red,'and Hang Up if needed.  You will be');
            WriteAT(22,11,white,red,'brought back to where you were when');
            WriteAT(22,12,white,red,'this program was loaded.');
            WriteAT(22,13,white,red,'(either at a menu or DOS)');
                          end;
                      2 : begin
            WriteAT(22,9,white,red, 'Use this option to TEMPORARILY exit');
            WriteAT(22,10,white,red,'to DOS, to do various things.  For');
            WriteAT(22,11,white,red,'example, you could format some disks,');
            WriteAT(22,12,white,red,'or edit a file.  You need only type');
            WriteAT(22,13,white,red,'EXIT to return; CLUB is in memory.');
                          end;
                      3 : begin
            WriteAT(22,9,white,red, 'This option will put you in the');
            WriteAT(22,10,white,red,'configuration section.  There you can');
            WriteAT(22,11,white,red,'input your Name, Password, what type');
            WriteAT(22,12,white,red,'of modem you are using, and other');
            WriteAT(22,13,white,red,'general information.');
                          end;
                 end; { Case Minor }

             2 : case Minor of
                      1 : begin
            WriteAT(22,9,white,red, 'Use this option to SEND a file to the');
            WriteAT(22,10,white,red,'host.  You should tell the host that');
            WriteAT(22,11,white,red,'you are !!!!!!!!!!!!!!!!!!firt so it');
            WriteAT(22,12,white,red,'knows wha do with the file.  Be sure');
            WriteAT(22,13,white,red,'you know e the file is on your drive.');
                          end;
                      2 : begin
            WriteAT(22,9,white,red, 'This option is to RECEIVE a file from');
            WriteAT(22,10,white,red,'the host.  You usually don''t need to');
            WriteAT(22,11,white,red,'do anythi!!!!!!!!!!!!!!!!!!!!I will');
            WriteAT(22,12,white,red,'know what to do with the file auto-');
            WriteAT(22,13,white,red,'matically.                 ');
                          end;
                      3 : begin
            WriteAT(22,9,white,red, 'Use this option to look around your  ');
            WriteAT(22,10,white,red,'disk drives to, for example, look for');
            WriteAT(22,11,white,red,'a file or to find out how much space');
            WriteAT(22,12,white,red,'is left on your Hard Drive.  This is');
            WriteAT(22,13,white,red,'much like the DOS command, DIR.');
                          end;
                 end; { Case Minor }

              3 : case Minor of
                      1 : begin
            WriteAT(22,9,white,red, 'Chosing this will DIAL the system you');
            WriteAT(22,10,white,red,'want to connect to.  If the line is');
            WriteAT(22,11,white,red,'BUSY, it will be re-dialed until you');
            WriteAT(22,12,white,red,'abort the procedure, or a connection');
            WriteAT(22,13,white,red,'has been made.');
                          end;
                      2 : begin
            WriteAT(22,9,white,red, 'This will HANG UP the phone, and thus');
            WriteAT(22,10,white,red,'disconnect you from the host.  Typing');
            WriteAT(22,11,white,red,'Alt-X or Exiting the program will');
            WriteAT(22,12,white,red,'automatically hang up for you, but');
            WriteAT(22,13,white,red,'this may be used if wanted.');
                          end;
                 end; { Case Minor }
            end; { major }
            Ch := GetKey;
            RmWin;
         end;
         { could put procs here, but have to accept cr, maj, min, AND letters }
      end;
      {$F-}

{$F+}
procedure IdleKeybd;
begin
end;
{$F-}

   Procedure MakeScreenInput;
   begin
      mkwin(1,1,80,25,yellow,black,2);
      ClearText(2,2,79,24,white,black);
       With Screen_Cols do
       begin
            WriteCenter(25,TextF,back,prgname+' Comm Program - (c) C. Kaitila');
            WriteCenter(1,HeadF,back,' Configiration Screen - F10 Save - Esc Exit ');
            WriteAt(9,3,TextF,back,'User Name:');
            WriteAT(9,4,TextF,back,'Password:');
            WriteAT(9,5,TextF,back,'Modem Baud:');
            WriteAT(9,6,TextF,back,'Comm Port:');
            WriteAT(9,7,TextF,back,'Dial String:');
            writeAT(9,8,TextF,back,'Init String:');
            writecenter(10,7,0,'Use arrow keys to move around');
            writecenter(11,7,0,'Ins, Del, Home, End work anywhere');
            writecenter(12,7,0,'Alt-E: Erase All, Alt-D: Delete Current field');
            writecenter(19,yellow,black,'Current Field Description:');
       end;
   end; {of proc Set_Screen}

   Procedure SetInputFields;
   {}
   var I : Integer;
   begin
       Create_Tables(1);
       Activate_Table(1);
       With Screen_Cols do
            Define_Colors(FieldHiF, FieldHiB, FieldLoF, FieldLoB, MsgF, MsgB);
       Allow_Esc(true);
       Create_Fields(6);
       Add_Field(1,  6,2,6,2,    22,3);
       Add_Field(2,  1,3,1,3,    22,4);
       Add_Field(3,  2,4,2,4,    22,5);
       Add_Field(4,  3,5,3,5,    22,6);
       Add_Field(5,  4,6,4,6,    22,7);
       Add_Field(6,  5,1,5,1,    22,8);
       String_Field(1, user.name,     replicate(30,'*'));
       Add_Message(1,0,20,'Enter your Name to be used while online at the '+prgname);
       String_Field(2, user.password, replicate(30,'*'));
       Add_Message(2,0,20,'This is the password that is sent to the host.  Security.');
       Integer_Field(3, user.baud,     '######',0,19200);
       Add_Message(3,0,20,'Enter the maximum BAUD rate (speed) that your MODEM is capable of.');
       byte_Field(4, user.Com,      '#',1,4);
       Add_Message(4,0,20,'Enter the Communications port # the MODEM is hooked up to.' );
       string_field(5, user.dialing,  '!!!!!!!!!!!!!!!!!!!!!!!!!');
       Add_Message(5,0,20,'Enter the Dialing String, usually ATDP=pulse or ATDT=tone' );
       string_field(6, user.initstr,  '!!!!!!!!!!!!!!!!!!!!!!!!!');
       Add_Message(6,0,20,'Enter the string sent during the initialization of the modem.' );
   end; {of proc Set_Fields}


procedure Unsetup;
begin
 Hangup;
 Com_Deinstall;

 If SettingsChanged then
 begin
  if FOut then close(FOutFile);
  write('Saving configuration..');
  Assign(ConfigFile,'CIBC.CFG');
  {$I-}
  rewrite(configfile);
  write(configfile,user);
  If Ioresult <> 0 then begin
   writeln('Error writing config changes to disk!'); halt; end;
  {$I+}
  for x := 1 to 23 do
   begin
   write('< ');
   delay(30);
   write('');
   end;
   write(' ');
 end;
end;

Procedure SetupMenu;
begin
    Fillchar(TheMenu,sizeof(TheMenu),#0);    {Empty the array}
    TheMenu[1] := '\Program';
    TheMenu[2] := ' Exit Program  ';
    TheMenu[3] := ' Shell to DOS  ';
    TheMenu[4] := ' Configuration ';
    TheMenu[5] := '\File/Printer';
    TheMenu[6] := ' Toggle Printer: OFF ';
    TheMenu[7] := ' Toggle File...: OFF ';
    TheMenu[8] := ' Directory Utility   ';
    TheMenu[9]  :='\Communicate';
    TheMenu[10] :=' Dial Club     ';
    TheMenu[11] :=' Hang Up       ';
    TheMenu[12]  :='\Help Me!';
    TheMenu[13] :=' About Modems  ';
    TheMenu[14] :=' This Program  ';
    TheMenu[15] := '\\';
    Major := 1;
    Minor := 3;
    PTTT.Hook := Menu_Procs;
    With PTTT do
    begin
        Style := 1;
        TopX := 3;
        TopY := 2;
        Gap :=  7;
        AlwaysDown := false;
    end;
end;

procedure Configuration;
begin
       With Screen_Cols do
            If BaseOfScreen = $B800 then {color}
            begin
                TextF    := white;
                Back     := Blue;
                MsgF     := yellow;
                MsgB     := red;
                FieldHiF := white;
                FieldHiB := red;
                FieldLoF := Lightgray;
                FieldLoB := black;
                BoxF     := lightcyan;
                HeadF    := white;
            end
            else
            begin
                TextF    := lightgray;
                Back     := black;
                MsgF     := white;
                MsgB     := black;
                FieldHiF := black;
                FieldHiB := lightgray;
                FieldLoF := white;
                FieldLoB := black;
                BoxF     := white;
                HeadF    := white;
            end;
 SettingsChanged := true;
 MakeScreenInput;
 SetInputFields;
 With Table[CurrentTable]^.ITTT do
  ErrorLine := 21;
 Process_Input(1);
 Dispose_Fields;
 rmwin; {the screen}
end;

procedure MakeWorkWindow(NumLines : integer);
begin
 MkWin(50,1,80,(2+NumLines),yellow,red,3);
end;

procedure Printer_Toggle;
begin
 If Pout then
  begin
  makeworkwindow(1);
  writeat(53,2,white,red,' Printer Output is now: OFF ');
  POut := false;
  themenu[6] := ' Toggle Printer: OFF  ';
  delay(600);
  rmwin;
  end
 else
  begin
   makeworkwindow(1);
   writeat(53,2,white,red,' Printer Output is now: ON ');
   POut := true;
   themenu[6] := ' Toggle Printer: ON   ';
   writeln(LST,'>> Printer Output Created on: '+date+' by '+prgname+' Comm Program <<');
   writeln(LST);
   delay(600);
   rmwin;
  end;
end;

procedure File_Toggle;
var  ch : char;
begin
If FOut then
 begin
  makeworkwindow(1);
  writeat(53,2,white,red,'File Output is now: OFF ');
  Fout := False;
  themenu[7] := ' Toggle File...: OFF ';
  delay(600);
  rmwin;
 end
Else { Not Fout }
 begin
  makeworkwindow(3);
  writeat(53,2,white,red,'Output to what File: ');
  ONCURSOR;
  writeat(53,3,yellow,red,'-->');
  gotoxy(57,3);
  textcolor(7);
  textbackground(red);
  readln(foutname);
  OFFCURSOR;
  if foutname <> '' then
  begin
    textcolor(7);
    textbackground(0);
    if exist(foutname) then
     begin
      writeat(53,3,14,red,'File EXISTS. Overwrite? ');
      ch := getkey;
      if (upcase(ch) = 'N') or (ch = '') then exit;
      writeat(77,3,white,red,ch);
     end;
    writeat(53,4,white,red,'File Output is now: ON ');
    FOut := true;
    Assign(FOutFile,FoutName);
    rewrite(foutfile);
    writeln(foutfile,' Output File Created on: '+date+' by '+prgname+' Comm Program ');
    writeln(foutfile,'');
    themenu[7] := ' Toggle File...: ON  ';
  end { if a name was entered }
 else
  writeat(53,4,black,red,'Function Aborted.');
  delay(600);
  rmwin;
 end;
end;

procedure DoDirectory;
begin
 tempmessagebox(3,1,lightcyan,black,3,' Directory stuff: UNFINISHED ');
end;

procedure ModemHelp;
begin
 tempmessagebox(1,15,white,black,2,'I''ll give LOTS of verbose info for idiots');
end;

procedure ProgHelp;
begin
 tempmessagebox(1,15,white,black,2,'I''ll give LOTS of verbose info for idiots');
end;

procedure CheckMenuChoice;
var x,y : integer;
begin
 case Major of
 1 : case Minor of
          1 : begin
               GoodbyeScrn;
               Unsetup;
               Halt;
              end;
          2 : begin
               savescreen(1);
               clrscr;
               writeat(1,1,lightgreen,black,'Type [----] to return!');
               writeat(7,1,white,black,'EXIT');
               gotoxy(1,2);
               oncursor;
               SwapVectors;
               Exec(Getenv('COMSPEC'),'');
               SwapVectors;
               restorescreen(1);
               disposescreen(1);
               offcursor;
              end;
          3 : begin
               Configuration;
              end;
     end; { Case Minor }

 2 : case Minor of
          1 : begin
               Printer_Toggle;
              end;
          2 : begin
               File_Toggle;
              end;
          3 : begin
               DoDirectory;
              end;
     end; { Case Minor }

 3 : case Minor of
          1 : begin
               DialIt;
              end;
          2 : begin
               gotoxy(oldx,oldy);
               writeln;
               writeln('>> Hanging Up <<');
               Hangup;
               Hangup;
               if carrier then
                begin
                 sendstr('+++');
                 delay(300);
                 sendstr('ATH0');
                end;
              end;
     end; { Case Minor }

 4 : case Minor of
          1 : begin
               ModemHelp;
              end;
          2 : begin
               ProgHelp;
              end;
     end; { Case Minor }

 end; { Case Major }
end;

procedure termloop; forward;

procedure MenuMaker;
begin
     oldx := wherex;
     oldy := wherey;
     offcursor;
     MkWin(7,1,73,1,white,black,0);
{8}  writecenter(1,lightcyan,blue,'   MENU: F1 for Help -- Esc to Return     Modem Status:           ');
     If carrier then writeAT(64,1,white,blue,'ONLINE') else
        writeAT(64,1,white,blue,'OFFLINE');
     Pull_Menu(TheMenu,Major,Minor);
     RmWin;
     if major <> 0 then CheckMenuChoice;
     oncursor;
     gotoxy(oldx,oldy);
end;

procedure TermLoop;
var quitit : boolean;
begin
quitit := false;
clrscr;
fbox(1,1,27,4,yellow,red,3);
writeat(3,2,white,red,' Ready to Communicate');
writeat(3,3,7,red   , 'F10: MENU - Alt-X: Quit');
gotoxy(1,5);
repeat {main}
     If keypressed then
     begin
      ch := getkey;
      case upcase(ch) of
       F10 : begin
               {if not carrier then }
               { begin }
               { write modem status? nah }
               { end; }
              menumaker;
             end; { F10pressed }
       AltX: quitit := true
       else  sendchar(ch); {send it if its not F10 or AltX}
      end; {case}
     end; {if keypressed}
     ch := getchar;
     if ch <> #0 then
      begin
{         fwrite('Online, writing char to: Screen - '); }
{         if pout then write('Printer - ');             }
{         if fout then write('and File.');              }
{         fwriteln('');                                 }
       {$I-}
       write(ch);
       if POut then write(Lst,ch);
       if FOut then write(FOutFile,ch);
       {$I+}
      end;
until quitit = true;
end;



procedure newconfigs;
begin
 {$I-}
 fwriteln('Making NEW configs with defaults...');
 rewrite(configfile);
 with user do
 begin
  Name := 'User Name';
  Password := 'Password';
  Baud := 1200;
  com := 1;
  dialing := 'ATDT';
  initstr := 'ATZ';
 end {with};
 write(configfile,user);
 {$I+}
 if ioresult > 0 then begin writeln('Error making new CIBC.CFG configs!'); Halt; end;
 reset(configfile);
end;

procedure LoadConfiguration;
begin
 Assign(Configfile,'CIBC.CFG');
 {$I-}
 Reset(configfile);
 read(configfile,user);
 {$I+}
 if ioresult > 0 then newconfigs;
 writeat(1,1,yellow,black,' Configuration Loaded');
 end;

procedure ModemSetup;
var anyerrors : word;
    Hmm : boolean;
begin
 { Modem Setup }
 Com_Install(user.com, AnyErrors);
 if anyerrors > 0 then {hmm} ;
 Setmodem;

 setparam(user.com,user.baud,false);
 com_set_parity(com_even,7);

 sendstr(user.initstr);
 if not waitferstr('OK',5,false,false) then
  tempmessagebox(1,3,lightred,black,2,' No "OK" returned when init string was sent. Press ENTER ');
 Dialit;
end;

procedure SetUpAll;
begin
    FOut := false;
    POut := false;
    textcolor(7);
    textbackground(0);
    { Assign_Idle_Hook(IdleKeybd); <-- None 4 now }
    SetupMenu;
    SettingsChanged := false;
    LoadConfiguration;
    ModemSetup;
end;

procedure StartUp;
begin
 TermLoop;
end;

{ ** MAIN ** }
begin
    WelcomeScrn;
    SetupAll;
    StartUp;
    { if Alt-X: }
    GoodbyeScrn;
    Unsetup; { save configs etc }
end.

