program makequicky;

uses dos, crt;

type protorec = record
              letter:char;
                desc:string[30];
            progname:string[12];
                comm:string[60];
              end;

var pro:file of protorec; prots:protorec; which:char;
    filenm: string[15];
    protlist:array [1..120] of protorec; count:integer; work:string[80];

procedure makefile(fname:string);
var ff:file of protorec; frec:protorec;
begin
     assign(ff,fname);
     rewrite(ff);
     frec.letter:='Z';
     frec.desc:='DSZ External Zmodem';
     frec.progname:='DSZ.COM';
     frec.comm:=' port %1 speed %2 sz %3';
     write(ff,frec);
     close(ff);
end;

function exist(fname:string):boolean;
var ff:file;
begin
     assign(ff,fname); {$I-};
     reset(ff); {$I+};
     exist:=(ioresult=0);
end;



procedure dobar(width:integer);
var ct:integer;
begin
     write('[');
     for ct:=1 to width do write('');
     writeln(']');
end;

procedure readyfile;
begin
     count:=0; reset(pro);
     while not eof(pro) do begin
               count:=count+1;
               read(pro,prots);
               protlist[count].letter:=prots.letter;
               protlist[count].desc:=prots.desc;
               protlist[count].comm:=prots.comm;
               protlist[count].progname:=prots.progname;
               end;
end;

Procedure DoLonglist;
var ct:integer;
begin;
      writeln;
      writeln('[---====<<<<<< Protocol List - (Quicky ][ by Doc D. Bugg) >>>>>>====---]');
      writeln('_#_ _Ltr_ ________Description__________  _________Command Line__________');

For ct:=1 to count do begin
          write(ct:2,'    ',protlist[ct].letter,'   ');
          writeln(protlist[ct].desc:30,' ',protlist[ct].progname+protlist[ct].comm);
          end;
      writeln;
end;

Procedure GetParm(addit:string; lump:integer);
begin
     writeln;
     writeln('Enter the ',addit,' protocol.');
     dobar(lump);
       write(':'); readln(work);
end;

procedure Add_Defaults;
var ch,pd,pp,pc : string;
    pl : char;
begin
 writeln;
 writeln('Add which protocol from list:');
 writeln;
 writeln('1 xmodemr:=dsz.com port %1 speed %2 rx -c %3');
 writeln('2 xmodems:=dsz.com port %1 speed %2 sx -k %3');
 writeln('3 ymodemr:=dsz.com port %1 speed %2 ry -c %3');
 writeln('4 ymodems:=dsz.com port %1 speed %2 sy -k %3');
 writeln('5 zmodemr:=dsz.com port %1 speed %2 rz %3');
 writeln('6 zmodems:=dsz.com port %1 speed %2 sz -s %3');
 writeln('7 jmodemr:=jmodem.com R%1 %3');
 writeln('8 jmodems:=jmodem.com S%1 %3');
 writeln('9 lynxr:=lynx.exe R /%1 /%2 %3');
 writeln('0 lynxs:=lynx.exe S /%1 /%2 %3');
 writeln('A xovrr:=dsz.com port %1 speed %2 ro %3');
 writeln('B xovrs:=dsz.com port %1 speed %2 so %3');
 writeln('C yovrr:=dsz.com port %1 speed %2 rb -o %3');
 writeln('D yovrs:=dsz.com port %1 speed %2 sb -o %3');
 writeln('E ymodemgr:=dsz.com port %1 speed %2 rb -g %3');
 writeln('F ymodemgs:=dsz.com port %1 speed %2 sb -g %3');
 writeln('G superkr:=superk.com p%1 s%2 rs f %3');
 writeln('H superks:=superk.com p%1 s%2 ss f %3');
 writeln('I k9xr:=superk.com p%1 s%2 rk f %3');
 writeln('J k9xs:=superk.com p%1 s%2 sk f %3');
 writeln('K zcrashr:=dsz.com port %1 speed %2 rz -r %3');
 writeln('L zcrashs:=dsz.com port %1 speed %2 sz -r %3');
 writeln('M zpcpr:=dsz.com port %1 speed %2 rz -w %3');
 writeln('N zpcps:=dsz.com port %1 speed %2 sz -w %3');
 writeln('O wxmodemr:=superk.com p%1 s%2 rw f %3');
 writeln('P wxmodems:=superk.com p%1 s%2 sw f %3');
 writeln('Q zrles:=dsz.com port %1 speed %2 sz -Z %3');
 writeln('R punterr:=punter.exe R P%1 B%1 %3');
 writeln('S punters:=punter.exe S P%1 B%1 %3');
 WRITELN;
 write('Which one? [Z quits]: ');
 readln(ch);
 case upcase(ch[1]) of
 '1' : begin pl := 'X'; pd := 'Xmodem'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 rx -c %3'; end;
 '2' : begin pl := 'X'; pd := 'Xmodem'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 sx -k %3'; end;
 '3' : begin pl := 'Y'; pd := 'Ymodem'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 ry -c %3'; end;
 '4' : begin pl := 'Y'; pd := 'Ymodem'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 sy -k %3'; end;
 '5' : begin pl := 'Z'; pd := 'Zmodem'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 rz %3'; end;
 '6' : begin pl := 'Z'; pd := 'Zmodem'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 sz -s %3'; end;
 '7' : begin pl := 'J'; pd := 'Jmodem'; pp := 'JMODEM.COM'; pc := 'R%1 %3'; end;
 '8' : begin pl := 'J'; pd := 'Jmodem'; pp := 'JMODEM.COM'; pc := 'S%1 %3'; end;
 '9' : begin pl := 'L'; pd := 'Lynx'; pp := 'LYNX.EXE'; pc := 'R /%1 /%2 %3'; end;
 '0' : begin pl := 'L'; pd := 'Lynx'; pp := 'LYNX.EXE'; pc := 'S /%1 /%2 %3'; end;
 'A' : begin pl := 'O'; pd := 'Xmodem-OD'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 ro %3'; end;
 'B' : begin pl := 'O'; pd := 'Xmodem-OD'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 so %3'; end;
 'C' : begin pl := 'V'; pd := 'Ymodem-OD'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 rb -o %3'; end;
 'D' : begin pl := 'V'; pd := 'Ymodem-OD'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 sb -o %3'; end;
 'E' : begin pl := 'G'; pd := 'Ymodem-G'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 rb -g %3'; end;
 'F' : begin pl := 'G'; pd := 'Ymodem-G'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 sb -g %3'; end;
 'G' : begin pl := 'S'; pd := 'Super-K'; pp := 'SUPERK.COM'; pc := 'p%1 s%2 rs f %3'; end;
 'H' : begin pl := 'S'; pd := 'Super-K'; pp := 'SUPERK.COM'; pc := 'p%1 s%2 ss f %3'; end;
 'I' : begin pl := 'K'; pd := 'K9-Xmodem'; pp := 'SUPERK.COM'; pc := 'p%1 s%2 rk f %3'; end;
 'J' : begin pl := 'K'; pd := 'K9-Xmodem'; pp := 'SUPERK.COM'; pc := 'p%1 s%2 sk f %3'; end;
 'K' : begin pl := 'C'; pd := 'Zmodem-Recover'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 rz -r %3'; end;
 'L' : begin pl := 'C'; pd := 'Zmodem-Recover'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 sz -r %3'; end;
 'M' : begin pl := 'P'; pd := 'Zmodem-PCP'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 rz -w %3'; end;
 'N' : begin pl := 'P'; pd := 'Zmodem-PCP'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 sz -w %3'; end;
 'O' : begin pl := 'W'; pd := 'WXmodem'; pp := 'SUPERK.COM'; pc := 'p%1 s%2 rf f %3'; end;
 'P' : begin pl := 'W'; pd := 'WXmodem'; pp := 'SUPERK.COM'; pc := 'p%1 s%2 sf f %3'; end;
 'Q' : begin pl := 'R'; pd := 'Zmodem-RLE'; pp := 'DSZ.COM'; pc := 'port %1 speed %2 sz -Z %3'; end;
 'R' : begin pl := 'T'; pd := 'Punter'; pp := 'PUNTER.EXE'; pc := 'R P%1 B%2 %3'; end;
 'S' : begin pl := 'T'; pd := 'Punter'; pp := 'PUNTER.EXE'; pc := 'S P%1 B%2 %3'; end;
 end;
 { Add it }
 inc(count);
 protlist[count].letter   := pl;
 protlist[count].desc     := pd;
 protlist[count].progname := pp;
 protlist[count].comm     := ' ' + pc;
end;


procedure Newprotocol;
begin
     writeln; count:=count+1;
     writeln('To be added as #',count,' to list.'); writeln;
     getparm('letter to respresent this',1); writeln;
     protlist[count].letter:=upcase(work[1]);
     getparm('description of the',30);
     protlist[count].desc:=copy(work,1,30);
     getparm('program name (i.e. DSZ.COM) of this',12);
     protlist[count].progname:=copy(work,1,12); writeln; writeln;
     writeln('Below show the PARAMETER ONLY portion of the command line');
     writeln('      Use : %1=Port   %2=Speed   %3=File/Pathname');
     writeln('      (Ex: port=%1 baud=%2 RZ %3)');
     getparm('command line for the',60);
     protlist[count].comm:=' '+copy(work,1,60);
     writeln; writeln(protlist[count].desc,' added.  [S]ave to make permanent.');
writeln('Be sure that ',protlist[count].progname,' exists in your 666 directory.');
     writeln;
end;

procedure deleteprotocol;
var delnum:integer; resp:char; lp:integer;
begin
     writeln;
     write('DELETE which protcol (#)? '); readln(delnum);
     if (delnum > count) or (delnum <= 0) then
                writeln('Invalid... must be between 1-',count,'!');
     if (delnum > count) or (delnum <= 0) then exit;
     writeln; write('Remove "',protlist[delnum].desc,'" from list? ');
     readln(resp); resp:=upcase(resp);
     if resp='N' then exit;
     for lp:=delnum to count do begin;
         protlist[lp].letter:=protlist[lp+1].letter;
         protlist[lp].desc  :=protlist[lp+1].desc;
         protlist[lp].comm  :=protlist[lp+1].comm;
       protlist[lp].progname:=protlist[lp+1].progname;
       end;
     writeln; writeln('Protocol Deleted.  [S]ave to make permanent.');
     writeln; count:=count-1;
end;

procedure savelist;
var ct:integer;
begin
     rewrite(pro);
     for ct:=1 to count do write(pro,protlist[ct]);
end;


begin;
      if not exist('PROT_R.DAT') then makefile('PROT_R.DAT');
      if not exist('PROT_S.DAT') then makefile('PROT_S.DAT');

      writeln('666 External Protocol Editor - Quicky ][ - Doc D. Bugg');
      writeln;
      write('Open: [R] Uploads,  [S] Downloads,  [U] Batch Up,  [D] Batch Down: ');
      readln(which);
      which:=upcase(which);
      filenm:='PROT_'+which+'.DAT';
      assign(pro,filenm);

      readyfile;
      writeln; writeln;
      writeln('Protcol File: ',filenm,' with ',count,' entries.');
      which:='X'; writeln;

      while (which<>'Q') do begin
            write('Edit: [!] Add from List  [L]ist  [S]ave  [Q]uit  [A]dd  [D]elete: ');
            readln(which); which:=upcase(which);
            case which of
                       'L'   : dolonglist;
                       'S'   : savelist;
                       'A'   : newprotocol;
                       'D'   : deleteprotocol;
                       '!'   : Add_Defaults;
                       end;
      end;
      writeln; writeln('Done: Returning to DOS'); close(pro);
end.
